{ 000705-1.PAS                                                              }
{ 2000-07-05 programmeerimisolmpiaadi 1. lesande lahendus                 }
{    KAS ON PUU?                                                            }
{ Ahto Truu                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

const
   fsis = 'GRAAF.SIS';                                   { sisendfaili nimi }
   fval = 'GRAAF.VAL';                                  { vljundfaili nimi }
   maxn = 20000;                          { maksimaalne tippude arv graafis }
   maxm = maxn + 1;
      { graafi tippude olekud }
   gt_sis = $0001;                                    { on sisenevaid servi }
   gt_val = $0002;                                     { on vljuvaid servi }
   gt_mag = $0004;                                { tipp on magasini pandud }

type
   jada = array [1..maxn] of integer;
   indeks = array[1..maxm] of integer;
   graaf = record
      n, t, r : integer;
      a, b, c : ^jada;
      x : ^indeks;
   end;
   magasin = record
      n : integer;
      a : ^jada;
   end;

{ operatsioonid magasiniga }

procedure tee_magasin (var m : magasin);
begin
   m.n := 0; new (m.a);
end;

procedure kustuta_magasin (var m : magasin);
begin
   dispose (m.a);
end;

procedure pane_magasini (var m : magasin; a : integer);
begin
   m.n := m.n + 1; m.a^[m.n] := a;
end;

function vota_magasinist (var m : magasin) : integer;
begin
   vota_magasinist := m.a^[m.n]; m.n := m.n - 1;
end;

function magasin_tuhi (var m : magasin) : boolean;
begin
   magasin_tuhi := m.n = 0;
end;

{ operatsioonid graafiga }

procedure tee_graaf (var g : graaf);
begin
   g.n := 0; new (g.a); new (g.b); new (g.c); new (g.x);
end;

procedure kustuta_graaf (var g : graaf);
begin
   dispose (g.a); dispose (g.b); dispose (g.c); dispose (g.x);
end;

function loe_graaf (var f : text; var g : graaf) : boolean;
var a, b, i : integer;
begin
   g.n := 0;
   read (f, a, b);
   if (a < 0) and (b < 0) then
      loe_graaf := false
   else begin
      while (a > 0) and (b > 0) do begin
         g.n := g.n + 1;
         if g.n <= maxn then begin
            g.a^[g.n] := a; g.b^[g.n] := b;
         end;
         read (f, a, b);
      end;
      loe_graaf := true;
   end;
   readln (f);
end;

function loenda_tipud (var g : graaf) : boolean;
var i : integer;
begin
   for i := 1 to maxn do
      g.c^[i] := 0;
   for i := 1 to g.n do begin
      g.c^[g.a^[i]] := g.c^[g.a^[i]] or gt_val;
      if g.c^[g.b^[i]] and gt_sis > 0 then begin
         loenda_tipud := false;
         exit;
      end;
      g.c^[g.b^[i]] := g.c^[g.b^[i]] or gt_sis;
   end;
   g.t := 0; g.r := 0;
   for i := 1 to maxn do begin
      if g.c^[i] > 0 then
         g.t := g.t + 1;
      if g.c^[i] = gt_val then
         if g.r > 0 then begin
            loenda_tipud := false;
            exit;
         end else
            g.r := i;
   end;
   loenda_tipud := (g.t = g.n + 1) and (g.r > 0);
end;

procedure sorteeri_servad (var g : graaf);
   procedure vaheta (i, j : integer);
   var c : integer;
   begin
      c := g.a^[i]; g.a^[i] := g.a^[j]; g.a^[j] := c;
      c := g.b^[i]; g.b^[i] := g.b^[j]; g.b^[j] := c;
   end;

   procedure vii_ules (i : integer);
   begin
      while i > 1 do
         if g.a^[i] > g.a^[i div 2] then begin
            vaheta (i, i div 2);
            i := i div 2;
         end else
            i := 1;
   end;

   procedure vii_alla (i, k : integer);
   var j : integer;
   begin
      while i < k do begin
         j := i;
         if 2 * i < k then
            if g.a^[j] < g.a^[2 * i] then
               j := 2 * i;
         if 2 * i + 1 < k then
            if g.a^[j] < g.a^[2 * i + 1] then
               j := 2 * i + 1;
         if j > i then begin
            vaheta (i, j);
            i := j;
         end else
            i := k;
      end;
   end;
var i : integer;
begin
   for i := 1 to g.n do
      vii_ules (i);
   for i := g.n downto 1 do begin
      vaheta (1, i);
      vii_alla (1, i);
   end;
end;

procedure indekseeri_servad (var g : graaf);
var i, k : integer;
begin
   i := 1; k := 1;
   for i := 1 to g.n do
      while k <= g.a^[i] do begin
         g.x^[k] := i;
         k := k + 1;
      end;
   for i := k to maxn + 1 do
      g.x^[i] := g.n + 1;
end;

function on_sidus (var g : graaf) : boolean;
var m : magasin; k, i : integer;
begin
   tee_magasin (m);
   pane_magasini (m, g.r);
   g.c^[g.r] := g.c^[g.r] or gt_mag;
   while not magasin_tuhi (m) do begin
      k := vota_magasinist (m);
      for i := g.x^[k] to g.x^[k + 1] - 1 do begin
         pane_magasini (m, g.b^[i]);
         g.c^[g.b^[i]] := g.c^[g.b^[i]] or gt_mag;
      end;
   end;
   for i := 1 to maxn do
      if g.c^[i] > 0 then
         if g.c^[i] and gt_mag = 0 then begin
            on_sidus := false;
            exit;
         end;
   on_sidus := true;
end;

function on_puu (var g : graaf) : boolean;
begin
   if g.n = 0 then
      on_puu := true
   else if g.n > maxn then
      on_puu := false
   else if not loenda_tipud (g) then
      on_puu := false
   else begin
      sorteeri_servad (g);
      indekseeri_servad (g);
      on_puu := on_sidus (g)
   end;
end;

var
   sisf : text;
   valf : text;
   k : integer;
   g : graaf;

begin
   assign (sisf, fsis); reset (sisf);
   assign (valf, fval); rewrite (valf);
   k := 0;
   tee_graaf (g);
   while loe_graaf (sisf, g) do begin
      k := k + 1;
      if on_puu (g) then
         writeln (valf, 'Komplekt ', k, ' on puu.')
      else
         writeln (valf, 'Komplekt ', k, ' ei ole puu.');
   end;
   kustuta_graaf (g);
   close (valf);
   close (sisf);
end.
