{ 000705-2.PAS                                                              }
{ 2000-07-05 programmeerimisolmpiaadi 2. lesande lahendus                 }
{    KAS ON PUU?                                                            }
{ Oleg Mrk                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

const
 N = 30;
 M = 30;
 EMPTY = '.';
 NO_STRING = 'EI SAA';
 INPUT_FILE = 'jooned.sis';
 OUTPUT_FILE = 'jooned.val';

type
 field = array[1..N, 1..N] of char;

var
 xs, ys : integer;
 end_n : integer;
 ends : array[1..M] of record
                           ch:char;
                           bch:char;
                           x1, y1:integer;
                           x2, y2:integer;
                       end;
 map : field;

 best_found:boolean;
 best_count:integer;
 best_map:field;

function LoCase(c:char):char;
begin
     if (c in ['A' .. 'Z']) then
        LoCase := char(ord(c) - ord('A') + ord('a'))
     else
         LoCase:=c;
end;



function evaluate_count_after(end_s:integer; var in_count, count_after:integer):boolean;
var
   len:array[1..M, 1..M] of integer;
   end_l:integer;
   l1, l2:integer;

   procedure fill_len(x, y, d:integer);
   begin
      if (x < 1) or (x > xs) then exit;
      if (y < 1) or (y > ys) then exit;

      if (map[x, y] <> EMPTY) and
         (map[x, y] <> ends[end_l].ch) then exit;

      if (len[x, y] > d) then
      begin
           len[x, y] := d;

           fill_len(x + 1, y, d + 1);
           fill_len(x - 1, y, d + 1);
           fill_len(x, y + 1, d + 1);
           fill_len(x, y - 1, d + 1);
      end;
   end;

begin
   in_count := 0;
   count_after := 0;

   for end_l:= end_s to end_n do
   begin
        { Reset lengths }
        for l1:=1 to xs do
             for l2:=1 to ys do
                 len[l1,l2] := maxint;

        { Fill lenghts }
        fill_len(ends[end_l].x1, ends[end_l].y1, 1);

        { If coulnd't reach endpoint }
        if (len[ends[end_l].x2, ends[end_l].y2] = maxint) then
        begin
             evaluate_count_after := false;
             exit;
        end;

        {Update}
        if (end_l = end_s) then
           in_count := len[ends[end_l].x2, ends[end_l].y2]
        else
            count_after := count_after +
                           len[ends[end_l].x2, ends[end_l].y2];
   end;

   evaluate_count_after := true;
end;

procedure search(
                 end_i:integer;
                 prev_x, prev_y:integer;
                 x,y:integer;
                 current_count:integer;
                 count_before, count_after:integer
                 );
var
   ch_save:char;
   in_count, new_count_after:integer;

   function verify_shortcut(dx,dy:integer):boolean;
   begin
        verify_shortcut := false;
        if (x + dx < 1) or (x + dx > xs) then exit;
        if (y + dy < 1) or (y + dy > ys) then exit;

        if (x + dx = prev_x) and (y + dy = prev_y) then exit;

        verify_shortcut := (map[x+dx, y+dy] = ends[end_i].bch);
   end;

   procedure update_best;
   begin
        if (not best_found) or
           (count_before + current_count < best_count) then
        begin
             best_found := true;
             best_count := count_before + current_count;
             best_map := map;
        end;
   end;

   procedure try_move(dx,dy:integer);
   begin
        if (x + dx < 1) or (x + dx > xs) then exit;
        if (y + dy < 1) or (y + dy > ys) then exit;

        if (map[x+dx, y+dy] <> EMPTY) and
           (map[x+dx, y+dy] <> ends[end_i].ch) then exit;

           search(
                  end_i,
                  x, y,
                  x+dx, y+dy,
                  current_count + 1,
                  count_before, count_after
                  );
   end;

begin
     if (
        verify_shortcut(1, 0) or
        verify_shortcut(-1, 0) or
        verify_shortcut( 0, 1) or
        verify_shortcut( 0,-1)
        )
        then exit;


     {Cut branches}
     if (best_found) and
        (count_before + current_count + count_after > best_count) then
        exit;


     {If completed line}
     if (x = ends[end_i].x2) and (y = ends[end_i].y2) then
     begin
          {If found solution}
          if (end_i = end_n) then
          begin
               update_best;
               exit;
          end;

          {If there is still hope}
          if evaluate_count_after(end_i + 1, in_count, new_count_after) then
          begin

               if (best_found) and
                  (count_before + current_count +
                   in_count + new_count_after > best_count) then exit;


               search(
                      end_i + 1,
                      -1, -1,
                      ends[end_i+1].x1, ends[end_i+1].y1,
                      1,
                      count_before + current_count, new_count_after
                      );
          end;

          {Complete}
          exit;
     end;

     {Update map}
     ch_save := map[x,y];
     map[x,y] := ends[end_i].bch;

     try_move( 1,  0);
     try_move(-1,  0);
     try_move( 0,  1);
     try_move( 0, -1);

     {Restore map}
     map[x,y]:= ch_save;
end;

procedure perform_search;
var
   in_count, count_after:integer;
begin
     if (end_n = 0) then
     begin
          best_found := true;
          best_count := 0;
          best_map := map;
          exit;
     end;

     best_found := false;

     if (evaluate_count_after(1, in_count, count_after)) then
        search(
               1,
               -1, -1,
               ends[1].x1,
               ends[1].y1,
               1,
               0, count_after
               );
end;


procedure load;
var
 f:text;
 ch:char;
 x, y:integer;

    procedure update_ch(x,y:integer);
    var
       l:integer;
    begin
         if (not (map[x,y] in ['A'..'Z'])) then exit;
         for l:=1 to end_n do
                  if (map[x,y] = ends[l].ch) then
                  begin
                       ends[l].x2 := x;
                       ends[l].y2 := y;
                       exit;
                  end;
         inc(end_n);
         ends[end_n].ch := map[x,y];
         ends[end_n].bch := LoCase(map[x,y]);
         ends[end_n].x1 := x;
         ends[end_n].y1 := y;
    end;

begin
     end_n := 0;

     assign(f, INPUT_FILE);
     reset(f);
     readln(f, xs, ys);

     for y:=1 to ys do
     begin
          for x:=1 to xs do
          begin
               read(f, map[x,y]);
               update_ch(x, y);
          end;
          readln(f);
     end;

     close(f);
end;

procedure store;
var
 f:text;
 i:integer;
 x,y:integer;
begin
     assign(f, OUTPUT_FILE);
     rewrite(f);

     if (not best_found) then
     begin
          writeln(f, NO_STRING);
          close(f);
          exit;
     end;

     {Set line endpoints}
     for i:= 1 to end_n do
     begin
          best_map[ends[i].x1, ends[i].y1] := ends[i].ch;
          best_map[ends[i].x2, ends[i].y2] := ends[i].ch;
     end;

     writeln(f, best_count);

     for y:=1 to ys do
     begin
          for x:=1 to xs do
              write(f, best_map[x,y]);
          writeln(f);
     end;

     close(f);
end;

begin
     load;
     perform_search;
     store;
end.
