{ 000705-3.PAS                                                              }
{ 2000-07-05 programmeerimisolmpiaadi 3. lesande lahendus                 }
{    VARJESTUS                                                              }
{ Ahto Truu                                                                 }
{ Testitud: TP 6.0, FPC 0.99.10                                             }

const
   fsis = 'VARJE.SIS';                                   { sisendfaili nimi }
   fval = 'VARJE.VAL';                                  { vljundfaili nimi }
   maxn = 1000;

type
   punkt = record
      x, y : real;
   end;
   ring = record
      c : punkt;
      r : real;
   end;

var
   n : integer;                                               { ringide arv }
   r : array [1..maxn] of ring;                       { ringide parameetrid }

{ konstrueerib vektori v = p1->p2 }
procedure vektor (var p1, p2, v : punkt);
begin
   v.x := p2.x - p1.x; v.y := p2.y - p1.y;
end;

{ arvutab skalaarkorrutise }
function skorr (var v1, v2 : punkt) : real;
begin
   skorr := v1.x * v2.x + v1.y * v2.y;
end;

{ arvutab vektorkorrutise (pikkuse (koos mrgiga)) }
function vkorr (var v1, v2 : punkt) : real;
begin
   vkorr := v1.x * v2.y - v2.x * v1.y;
end;

{ leiab v1 ja v2 vahelise nurga (eeldab, et see on alla pi/2) }
function nurk (var v1, v2 : punkt) : real;
begin
   nurk := arctan (vkorr (v1, v2) / skorr (v1, v2));
end;

{ arvutab v2 = v1 pratud nurga a vrra }
procedure poora (var v2, v1 : punkt; sina, cosa : real);
begin
   v2.x := v1.x * cosa - v1.y * sina;
   v2.y := v1.y * cosa + v1.x * sina;
end;

{ leiab, kas v1 nurk <= v nurk < v2 nurk }
function vahel (var v, v1, v2 : punkt) : boolean;
begin
   if vkorr (v1, v) < 0 then
      vahel := false
   else if vkorr (v2, v) < 0 then
      vahel := true
   else
      vahel := false;
end;

{ lisab kattesse jrgmise serva vektorite t1 ja t2 suuna vahel }
function lisa_serv (var l : real; var k : integer; var t1, t2 : punkt) : boolean;
var kk, i : integer; v, w, t : punkt; a, b, c, cc, ll : real;
begin
   { leiame vhima prdega serva }
   kk := 0; t := t2;
   for i := 1 to n do
      if i <> k then begin
         vektor (r[k].c, r[i].c, v);
         cc := sqr (v.x) + sqr (v.y); c := sqrt (cc);
         a := r[k].r - r[i].r; b := sqrt (cc - sqr (a));
         poora (w, v, a / c, b / c);
         if vahel (w, t1, t) then begin
            kk := i; ll := b; t := w;
         end;
      end;

   { kui oli serv, lisame kattesse }
   if kk > 0 then begin
      l := l + r[k].r * nurk (t1, t) + ll;
      k := kk;
      t1 := t;
      { kui eelnev omistamine t1 := t hakkab mingil hetkel }
      { hel sirgel olevaid like vahele jtma, siis tuleb }
      { selle asemel sisse tuua allolev "veaparandus"      }
      { poora (t1, t, sin (-1e-9), cos (-1e-9));           }
      lisa_serv := true;
   end else
      lisa_serv := false;
end;

{ lisab kattesse sektori t1 sihist t2 sihini }
procedure lisa_sektor (var l : real; var k : integer; t1, t2 : punkt);
begin
   while (lisa_serv (l, k, t1, t2)) do
      ;
   l := l + r[k].r * nurk (t1, t2);
end;

function leia_kate : real;
var k, i : integer; l : real;
const t : array [1..8] of punkt =
   ((x : 1; y : 0), (x : 1; y : 1), (x : 0; y : 1), (x : -1; y : 1),
    (x : -1; y : 0), (x : -1; y : -1), (x : 0; y : -1), (x : 1; y : -1));
begin
   { otsime alguspunkti }
   k := 1;
   for i := 1 to n do begin
      if r[i].c.y - r[i].r < r[k].c.y - r[k].r then
         k := i;
      if r[i].c.y - r[i].r = r[k].c.y - r[k].r then
         if r[i].c.x < r[k].c.x then
            k := i;
   end;

   { arvutame katte kaheksandike kaupa }
   l := 0;
   for i := 1 to 8 do
      lisa_sektor (l, k, t[i], t[i mod 8 + 1]);
   leia_kate := l;
end;

procedure loe_sisend;
var f : text; i : integer;
begin
   assign (f, fsis); reset (f);
   readln (f, n);
   for i := 1 to n do
      readln (f, r[i].c.x, r[i].c.y, r[i].r);
   close (f);
end;

procedure tee_valjund (l : real);
var f : text;
begin
   assign (f, fval); rewrite (f);
   writeln (f, l :0:2);
   close (f);
end;

begin
   loe_sisend;
   tee_valjund (leia_kate);
end.
